#include </home/T4F/terrain/tcl7.4/Dist-irix/include/tcl.h>
#include </home/T4F/terrain/tk4.0/Dist-irix/include/tk.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>

#include "defs.h"
#include "shmem.h"
#include "mapdefs.h"

#define ERROR -1

static int   semid_file0, semid_file1, semid_file2, semid_file3;
static int   sem_cgi, sem_mutex, shmid;   /* globals for semid and shmid */
FILE         *logfile;
int          datasock, ctrlsock;

char       curr_file[MAX_FILENAMELEN];
Neighbours neighbours;
static     Next_Cell next_cells[2];
static int move_count[5];
static int last_update, last_move;
static int *file_lock;
static int toggle;
static int cell_content[16];
static int mapmat_north, mapmat_south, mapmat_east, mapmat_west;
static int xmax, ymax;
static int bndry[5];
static int pipefd[2];
int        bound_north, bound_south, bound_east, bound_west, res,
           row, col; 

extern int FingerHost(char *hostname, int len);
extern int SetupConn(int *datasock, int *ctrlsock, int *bound_north, 
                     int *bound_south, int *bound_east, 
                     int *bound_west, int *res, int *row, int *col);
extern void CommQuit(int datasock, int ctrlsock);
void       MyInterr(int signo);
void       SetNeighbours(int i, int j);
void       ResetLinks(int focus_i, int focus_j, int last_update,
                      Tcl_Interp *interp);
void       JumpToNextSegment(int dir, int focus_i, int focus_j, 
                             Tcl_Interp *interp);
void       GetCells(int dir);
void       GetCells1(int dir);
void       GetCells2(int dir);
void       GetCells3(int dir);
void       GetCells4(int dir);


int SetMapBounds(ClientData clientData, Tcl_Interp *interp, int argc,
                 char **argv) {

  char buf[20];

  memset(buf, '\0', 20);
  sprintf(buf, "%d", bound_north);
  Tcl_SetVar(interp, "north", buf, 0);
  memset(buf, '\0', 20);
  sprintf(buf, "%d", bound_south);
  Tcl_SetVar(interp, "south", buf, 0);
  memset(buf, '\0', 20);
  sprintf(buf, "%d", bound_east);
  Tcl_SetVar(interp, "east", buf, 0);
  memset(buf, '\0', 20);
  sprintf(buf, "%d", bound_west);
  Tcl_SetVar(interp, "west", buf, 0);
  xmax = floor((double)((bound_east - bound_west)/res));
  ymax = floor((double)((bound_north - bound_south)/res));
  memset(buf, '\0', 20);
  sprintf(buf, "%d", xmax);
  Tcl_SetVar(interp, "x_max", buf, 0);
  memset(buf, '\0', 20);
  sprintf(buf, "%d", ymax);
  Tcl_SetVar(interp, "y_max", buf, 0);

  /* set the initial 3x3 map matrix boundary coordinates */
  mapmat_west = (col - SEGMENT_WIDTH)*res + bound_west;
  mapmat_east = mapmat_west + 3*SEGMENT_WIDTH*res;
  mapmat_north = bound_north - (row - SEGMENT_HEIGHT)*res;
  mapmat_south = mapmat_north - 3*SEGMENT_HEIGHT*res;

  printf("mapmatn: %d mapmats: %d mapmatw: %d ampmate: %d\n", \
          mapmat_north, mapmat_south, mapmat_west, mapmat_east);

  return TCL_OK;
}




int SetupCanvasCoords(ClientData clientData, Tcl_Interp *interp, int argc,
                      char **argv) {

  char buf[20];
  int  temp, focus_i, focus_j;
  
  memset(buf, '\0', 20);
  sprintf(buf, "%d", col);
  Tcl_SetVar(interp, "canvas_llx", buf, 0);
  temp = col + SEGMENT_WIDTH;
  memset(buf, '\0', 20);
  sprintf(buf, "%d", temp);
  Tcl_SetVar(interp, "canvas_urx", buf, 0);
  memset(buf, '\0', 20);
  sprintf(buf, "%d", row);
  Tcl_SetVar(interp, "canvas_ury", buf, 0);
  temp = row + SEGMENT_HEIGHT;
  memset(buf, '\0', 20);
  sprintf(buf, "%d", temp);
  Tcl_SetVar(interp, "canvas_lly", buf, 0);
/*  focus_i = col/SEGMENT_WIDTH; */
  focus_i = 1;
  memset(buf, '\0', 20);
  sprintf(buf, "%d", focus_i);
  Tcl_SetVar(interp, "focus_i", buf, 0);
/*  focus_j = row/SEGMENT_HEIGHT; */
  focus_j = 1;
  memset(buf, '\0', 20);
  sprintf(buf, "%d", focus_j);
  Tcl_SetVar(interp, "focus_j", buf, 0);
  Tcl_Eval(interp, "set display_ury $canvas_ury");
  Tcl_Eval(interp, "set display_lly [expr $canvas_ury + $imgwin_height]");
  Tcl_Eval(interp, "set display_llx $canvas_llx");
  Tcl_Eval(interp, "set display_urx [expr $display_llx + $imgwin_width]");

  return TCL_OK;
}




int Quit(ClientData clientData, Tcl_Interp *interp, int argc,
         char **argv) {

  char buf[120];

  if (semid_file0) SemRem(semid_file0);
  if (semid_file1) SemRem(semid_file1);
  if (semid_file2) SemRem(semid_file2);
  if (semid_file3) SemRem(semid_file3);
  if (sem_mutex) SemRem(sem_mutex);
  if (pipefd[0]) close (pipefd[0]);
  if (pipefd[1]) close (pipefd[1]);
  sprintf(buf, "%d %d %d %d %d %d %d %d %d %d %d %d",
          -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
                 /* this is the exit signal to the server */
  if (WriteBytes(datasock, buf, 120) != 120) {
   interp->result = "ERROR: In writing next segment coords to data channel";
   return TCL_ERROR;
  }
  CommQuit(datasock, ctrlsock);  /* close the sockets for this session */
  remove("loclist");  /* remove the url list file */

  return TCL_OK;
}



int OpenUrl(ClientData clientData, Tcl_Interp *interp, int argc,
        char **argv) {

  char combuf[320];
  char hostname[MAXHOSTNAMELEN+1];
  char str[80];

  fprintf(logfile, "argv1: %s\n", argv[1]);
  fflush(logfile);
  strcpy(combuf, "netscape -display ");
  FingerHost(hostname, MAXHOSTNAMELEN+1);
  memset(str, '\0', 80);
  strcat(str, hostname);
  strcat(str, ":0");
  strcat(combuf, str);
  strcat(combuf, " -remote 'openURL(");
  strcat(combuf, argv[1]);
  strcat(combuf, ")'");
  system(combuf);
  fprintf(logfile, "%s\n", combuf);
  fflush(logfile);

  return TCL_OK;

}




int InitDisplay(ClientData clientData, Tcl_Interp *interp, int argc,
                char **argv) {

  int i, j, m, n, indx;
  char buf[10];
 
  if (argc != 3) {
      interp->result = "wrong # args";
      return TCL_ERROR;
  }

  sscanf(argv[1], "%d", &i);
  sscanf(argv[2], "%d", &j);

  strcpy(curr_file, "seg_0.");
  sprintf(buf, "%d.", i);
  strcat(curr_file, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", j);
  strcat(curr_file, buf);

  SetNeighbours(i, j);
  move_count[1] = 0;
  move_count[2] = 0;
  move_count[3] = 0;
  move_count[4] = 0;

  last_update = 0;
  last_move = 0;
  toggle = 0;

/* set the cell_content array */
  for (m = 0; m < 4; m++) {
   for (n = 0; n < 4; n++) {
      indx = m*4 + n;
      cell_content[indx] = indx;
   }
  }

  return TCL_OK;
}




int UpdateLinks(ClientData clientData, Tcl_Interp *interp, int argc,
                char **argv) {

  int dir, focus_i, focus_j;
  int i, j;
  int reset_flag;

  if (argc != 4) {
      interp->result = "wrong # args";
      return TCL_ERROR;
  }
  sscanf(argv[1], "%d", &dir);
  sscanf(argv[2], "%d", &focus_i);
  sscanf(argv[3], "%d", &focus_j);
  if (last_update == 0)  /* first time, so initialize */
    last_update = dir;
  Tcl_GetInt(interp, Tcl_GetVar(interp, "reset_flag", 0), &reset_flag);
 
  if (reset_flag == 1) /* canvas was not updated!, so reset links */
    ResetLinks(focus_i, focus_j, last_update, interp);
  last_move = move_count[dir];

  if (dir == 3 || dir == 4) {
    move_count[dir] += 1;
    if (move_count[dir] == 0)
      move_count[dir] = 1;
    move_count[dir-2] -= 1; 
    if (move_count[dir-2] == -1)
      move_count[dir-2] = -2;
    GetCells(dir);
/* debug
printf("focus_i: %d focus_j %d\n", focus_i, focus_j);
printf("file: %s %s\n", next_cells[0].next_file, next_cells[1].next_file);
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++)
          printf("i: %d j: %d %d %d %d %d\n", i, j, next_cells[i].istart[j], next_cells[i].iend[j], next_cells[i].jstart[j], next_cells[i].jend[j]);
 !debug */
    if (move_count[dir] == 4)
      JumpToNextSegment(dir, focus_i, focus_j, interp);
  }

  if (dir == 1 || dir == 2) {
    move_count[dir] += 1;
    if (move_count[dir] == 0)
      move_count[dir] = 1;
    move_count[dir+2] -= 1;
    if (move_count[dir+2] == -1)
      move_count[dir+2] = -2;
    GetCells(dir);
    if (move_count[dir] == 4)
      JumpToNextSegment(dir, focus_i, focus_j, interp);
  }

  last_update = dir;
  return TCL_OK;
}




void JumpToNextSegment(int dir, int focus_i, int focus_j, Tcl_Interp *interp) {

  char  cmd0[] = "if {$focus_i < $max_cell_cols} { set focus_i [expr $focus_i + 1]}";
  char  cmd1[] = "if {$focus_j < $max_cell_rows} { set focus_j [expr $focus_j + 1]}";
  char  cmd2[] = "if {$focus_i > 0 } { set focus_i [expr $focus_i - 1]}";
  char  cmd3[] = "if {$focus_j > 0 } { set focus_j [expr $focus_j - 1]}";

  if (dir == 4)  {
    move_count[dir] = 0;
    move_count[dir-2] = 0;
    memset(curr_file, '\0', MAX_FILENAMELEN);
    strcpy(curr_file, neighbours.segments[E]);
    focus_i += 1;
    Tcl_Eval(interp, cmd0);
    SetNeighbours(focus_i, focus_j);
  } else if (dir == 3) {
    move_count[dir] = 0;
    move_count[dir-2] = 0;
    memset(curr_file, '\0', MAX_FILENAMELEN);
    strcpy(curr_file, neighbours.segments[S]);
    focus_j += 1;
    Tcl_Eval(interp, cmd1);
    SetNeighbours(focus_i, focus_j);
  } else if (dir == 2) {
    move_count[dir] = 0;
    move_count[dir+2] = 0;
    memset(curr_file, '\0', MAX_FILENAMELEN);
    strcpy(curr_file, neighbours.segments[W]);
    focus_i -= 1;
    Tcl_Eval(interp, cmd2);
    SetNeighbours(focus_i, focus_j);
  } else if (dir == 1) {
    move_count[dir] = 0;
    move_count[dir+2] = 0;
    memset(curr_file, '\0', MAX_FILENAMELEN);
    strcpy(curr_file, neighbours.segments[N]);
    focus_j -= 1;
    Tcl_Eval(interp, cmd3);
    SetNeighbours(focus_i, focus_j);
  }

  return;
}





void ResetLinks(int focus_i, int focus_j, int last_update, 
                Tcl_Interp *interp) {

  char  cmd0[] = "set focus_i [expr $focus_i - 1]";
  char  cmd1[] = "set focus_j [expr $focus_j - 1]";
  char  cmd2[] = "set focus_i [expr $focus_i + 1]";
  char  cmd3[] = "set focus_j [expr $focus_j + 1]";

  if (move_count[last_update] == 0) {
    if (last_move > 0)
      if (last_update == 4) {
        memset(curr_file, '\0', MAX_FILENAMELEN);
        strcpy(curr_file, neighbours.segments[W]);
        focus_i -= 1;
        Tcl_Eval(interp, cmd0);
        SetNeighbours(focus_i, focus_j);
      } else if (last_update == 3) {
        memset(curr_file, '\0', MAX_FILENAMELEN);
        strcpy(curr_file, neighbours.segments[N]);
        focus_j -= 1;
        Tcl_Eval(interp, cmd1);
        SetNeighbours(focus_i, focus_j);
      } else if (last_update == 2) {
        memset(curr_file, '\0', MAX_FILENAMELEN);
        strcpy(curr_file, neighbours.segments[E]);
        focus_i += 1;
        Tcl_Eval(interp, cmd2);
        SetNeighbours(focus_i, focus_j);
      } else if (last_update == 1) {
        memset(curr_file, '\0', MAX_FILENAMELEN);
        strcpy(curr_file, neighbours.segments[S]);
        focus_j += 1;
        Tcl_Eval(interp, cmd3);
        SetNeighbours(focus_i, focus_j);
      } 
  }
  move_count[last_update] = last_move;
/*  if (move_count[last_update] == 0)
    move_count[last_update] = -1; */

  if (last_update == 3 || last_update == 4) {
    if (move_count[last_update-2] == 0)
      if (last_move > 0)
        move_count[last_update-2] = -4;
      else
        move_count[last_update-2] = 1;
    else {
      move_count[last_update-2]++;
      if (move_count[last_update-2] == -1)
        move_count[last_update-2] = 0;
    }
  } else if (last_update == 1 || last_update == 2) {
    if (move_count[last_update+2] == 0)
      if (last_move > 0)
        move_count[last_update+2] = -4;
      else
        move_count[last_update+2] = 1;
    else {
      move_count[last_update+2]++;
      if (move_count[last_update+2] == -1)
        move_count[last_update+2] = 0;
    }
  }

    return;
}




void GetCells(int dir) {

  int i, j;

  for (i = 0; i < 2; i++) {
    memset(next_cells[i].next_file, '\0', MAX_FILENAMELEN);
    for (j = 0; j < MAX_CELL_ROWS; j++) {
      next_cells[i].istart[j] = 0;
      next_cells[i].iend[j] = 0;
      next_cells[i].jstart[j] = 0;
      next_cells[i].jend[j] = 0;
    }
  }
  if (dir == 1) {
    GetCells1(dir);
  } else if (dir == 2) {
    GetCells2(dir);
  } else if (dir == 3) {
    GetCells3(dir);
  } else if (dir == 4) {
    GetCells4(dir);
  }

  return;
}




void GetCells1(int dir) {

  int i, j;

    if (move_count[dir] > 0)
      strcpy(next_cells[0].next_file, neighbours.segments[N]);
    else
      strcpy(next_cells[0].next_file, curr_file);

   for (j = 0; j < MAX_CELL_ROWS; j++) {
     next_cells[0].istart[j] = j * MAP_CELL_WIDTH;
     next_cells[0].iend[j] = next_cells[0].istart[j] + MAP_CELL_WIDTH;
   }

    if (move_count[dir] == 1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 3 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 4 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == 2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 2 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 3 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == 3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 2 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == 4) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 0;
          next_cells[i].jend[j] =  MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == -1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 0;
          next_cells[i].jend[j] = MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == -2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 2 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == -3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 2 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 3 * MAP_CELL_HEIGHT;
        }
    }
    
    if (move_count[2] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[NW]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[W]);
      for (j = 0; j < MAX_CELL_COLS-move_count[2]; j++)
        next_cells[1].istart[j] = next_cells[1].iend[j] = 0;
      for (j = MAX_CELL_COLS - move_count[2]; j < MAX_CELL_COLS; j++) {
        next_cells[1].istart[j] = j * MAP_CELL_WIDTH;
        next_cells[1].iend[j] = next_cells[1].istart[j] + MAP_CELL_WIDTH;
        next_cells[0].istart[j] = next_cells[0].iend[j] = 0;
      }
    }
    if (move_count[4] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[NE]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[E]);
      for (j = 0; j < move_count[4]; j++) {
        next_cells[1].istart[j] = j * MAP_CELL_WIDTH;
        next_cells[1].iend[j] = next_cells[1].istart[j] + MAP_CELL_WIDTH;
        next_cells[0].istart[j] = next_cells[0].iend[j] = 0;
      }
      for (j = move_count[4]; j < MAX_CELL_COLS; j++)
        next_cells[1].istart[j] = next_cells[1].iend[j] = 0;
    }

  return;
}




void GetCells2(int dir) {

  int i, j;

    if (move_count[dir] > 0)
      strcpy(next_cells[0].next_file, neighbours.segments[W]);
    else
      strcpy(next_cells[0].next_file, curr_file);

   for (j = 0; j < MAX_CELL_ROWS; j++) {
     next_cells[0].jstart[j] = j * MAP_CELL_HEIGHT;
     next_cells[0].jend[j] = next_cells[0].jstart[j] + MAP_CELL_HEIGHT;
   }

    if (move_count[dir] == 1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 3 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 4 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == 2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 2 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 3 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == 3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 2 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == 4) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 0;
          next_cells[i].iend[j] = MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == -1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 0;
          next_cells[i].iend[j] = MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == -2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 2 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == -3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 2 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 3 * MAP_CELL_WIDTH;
        }
    }
    
    if (move_count[1] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[NW]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[N]);
      for (j = 0; j < MAX_CELL_ROWS-move_count[1]; j++)
        next_cells[1].jstart[j] = next_cells[1].jend[j] = 0;
      for (j = MAX_CELL_ROWS - move_count[1]; j < MAX_CELL_ROWS; j++) {
        next_cells[1].jstart[j] = j * MAP_CELL_HEIGHT;
        next_cells[1].jend[j] = next_cells[1].jstart[j] + MAP_CELL_HEIGHT;
        next_cells[0].jstart[j] = next_cells[0].jend[j] = 0;
      }
    }
    if (move_count[3] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[SW]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[S]);
      for (j = 0; j < move_count[3]; j++) {
        next_cells[1].jstart[j] = j * MAP_CELL_HEIGHT;
        next_cells[1].jend[j] = next_cells[1].jstart[j] + MAP_CELL_HEIGHT;
        next_cells[0].jstart[j] = next_cells[0].jend[j] = 0;
      }
      for (j = move_count[3]; j < MAX_CELL_ROWS; j++)
        next_cells[1].jstart[j] = next_cells[1].jend[j] = 0;
    }

  return;
}




void GetCells3(int dir) {

  int i, j;

    if (move_count[dir] > 0)
      strcpy(next_cells[0].next_file, neighbours.segments[S]);
    else
      strcpy(next_cells[0].next_file, curr_file);

   for (j = 0; j < MAX_CELL_ROWS; j++) {
     next_cells[0].istart[j] = j * MAP_CELL_WIDTH;
     next_cells[0].iend[j] = next_cells[0].istart[j] + MAP_CELL_WIDTH;
   }

    if (move_count[dir] == 1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 0;
          next_cells[i].jend[j] = MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == 2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 2 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == 3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 2 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 3 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == 4) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 3 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] =  4 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == -1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 3 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 4 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == -2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = 2 * MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 3 * MAP_CELL_HEIGHT;
        }
    } else if (move_count[dir] == -3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_COLS; j++) {
          next_cells[i].jstart[j] = MAP_CELL_HEIGHT;
          next_cells[i].jend[j] = 2 * MAP_CELL_HEIGHT;
        }
    }
    
    if (move_count[2] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[SW]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[W]);
      for (j = 0; j < MAX_CELL_COLS-move_count[2]; j++)
        next_cells[1].istart[j] = next_cells[1].iend[j] = 0;
      for (j = MAX_CELL_COLS - move_count[2]; j < MAX_CELL_COLS; j++) {
        next_cells[1].istart[j] = j * MAP_CELL_WIDTH;
        next_cells[1].iend[j] = next_cells[1].istart[j] + MAP_CELL_WIDTH;
        next_cells[0].istart[j] = next_cells[0].iend[j] = 0;
      }
    }
    if (move_count[4] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[SE]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[E]);
      for (j = 0; j < move_count[4]; j++) {
        next_cells[1].istart[j] = j * MAP_CELL_WIDTH;
        next_cells[1].iend[j] = next_cells[1].istart[j] + MAP_CELL_WIDTH;
        next_cells[0].istart[j] = next_cells[0].iend[j] = 0;
      }
      for (j = move_count[4]; j < MAX_CELL_COLS; j++)
        next_cells[1].istart[j] = next_cells[1].iend[j] = 0;
    }

  return;
}




void GetCells4(int dir) {

  int i, j;

    if (move_count[dir] > 0)
      strcpy(next_cells[0].next_file, neighbours.segments[E]);
    else
      strcpy(next_cells[0].next_file, curr_file);

    for (j = 0; j < MAX_CELL_ROWS; j++) {
      next_cells[0].jstart[j] = j * MAP_CELL_HEIGHT;
      next_cells[0].jend[j] = next_cells[0].jstart[j] + MAP_CELL_HEIGHT;
    }

    if (move_count[dir] == 1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 0;
          next_cells[i].iend[j] = MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == 2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 2 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == 3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 2 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 3 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == 4) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 3 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 4 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == -1) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 3 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 4 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == -2) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = 2 * MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 3 * MAP_CELL_WIDTH;
        }
    } else if (move_count[dir] == -3) {
      for (i = 0; i < 2; i++) 
        for (j = 0; j < MAX_CELL_ROWS; j++) {
          next_cells[i].istart[j] = MAP_CELL_WIDTH;
          next_cells[i].iend[j] = 2 * MAP_CELL_WIDTH;
        }
    }
    
    if (move_count[1] > 0) {
      if (move_count[dir] > 0) {
        strcpy(next_cells[1].next_file, neighbours.segments[NE]);
      } else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[N]);
      for (j = 0; j < MAX_CELL_ROWS-move_count[1]; j++)
        next_cells[1].jstart[j] = next_cells[1].jend[j] = 0;
      for (j = MAX_CELL_ROWS - move_count[1]; j < MAX_CELL_ROWS; j++) {
        next_cells[1].jstart[j] = j * MAP_CELL_HEIGHT;
        next_cells[1].jend[j] = next_cells[1].jstart[j] + MAP_CELL_HEIGHT;
        next_cells[0].jstart[j] = next_cells[0].jend[j] = 0;
      }
    }

/* debug
printf("first print\n");
for (i = 0; i < 2; i++)  {
   for (j = 0; j < MAX_CELL_ROWS; j++) 
printf("%d %d %d %d\n", next_cells[i].istart[j], next_cells[i].iend[j], next_cells[i].jstart[j], next_cells[i].jend[j]);
 printf("\n\n");
}
!debug */
    if (move_count[3] > 0) {
      if (move_count[dir] > 0)
        strcpy(next_cells[1].next_file, neighbours.segments[SE]);
      else if (move_count[dir] < 0)
        strcpy(next_cells[1].next_file, neighbours.segments[S]);
      for (j = 0; j < move_count[3]; j++) {
        next_cells[1].jstart[j] = j * MAP_CELL_HEIGHT;
        next_cells[1].jend[j] = next_cells[1].jstart[j] + MAP_CELL_HEIGHT;
        next_cells[0].jstart[j] = next_cells[0].jend[j] = 0;
      }
      for (j = move_count[3]; j < MAX_CELL_ROWS; j++)
        next_cells[1].jstart[j] = next_cells[1].jend[j] = 0;
    }

  return;
}




int LookAhead(ClientData clientData, Tcl_Interp *interp, int argc,
              char **argv) {

  int    dir, type;
  char   *filenames[2];
  static int init;
  char  cmd0[] = "set file_toggle 0";
  char  cmd1[] = "set file_toggle 1";
  int   pid;
  int   i, j;

  if (argc != 2) {
      interp->result = "wrong # args";
      return TCL_ERROR;
  }

  sscanf(argv[1], "%d", &dir);

/* avoid race conditions: only one lookahead at at time! */
  if (init) {
    printf("parent waiting on mutex\n");
    fflush(stdout);
    if (SemWait(sem_mutex) == ERROR) {
      interp->result = "parent: wait error on mutex";
      return TCL_ERROR;
    }
    if (SemSignal(sem_mutex) == ERROR) {
      interp->result = "parent: signalling error on mutex";
      return TCL_ERROR;
    }
  }
  if ((pid = fork()) < 0) { 
    interp->result = "fork error";
    return TCL_ERROR;
  } else if (pid == 0) { /* child extracts adjacent cells */
    if (!init) sleep(1);
                 /* wait for parent to create the mutex semaphore first */
    if ((sem_mutex = SemOpen(SEM_MUTEX)) == ERROR) {
      printf("child couldn't open mutex  semaphore\n");
      exit(0);
    }
    printf("child waiting on mutex\n");
    fflush(stdout);
    SemWait(sem_mutex);  /* mutual exclusion */
    /* first get locks on the output files */
    if ((semid_file0 = SemOpen(SEM_FL_KEY0)) == ERROR ||
        (semid_file1 = SemOpen(SEM_FL_KEY1)) == ERROR ||
        (semid_file2 = SemOpen(SEM_FL_KEY2)) == ERROR ||
        (semid_file3 = SemOpen(SEM_FL_KEY3)) == ERROR) {
      interp->result = "child couldn't open file lock semaphores";
      exit(0);
    }
    SemWait(semid_file0);
    SemWait(semid_file1);
    SemWait(semid_file2);
    SemWait(semid_file3);
    extract_cells(semid_file0, semid_file1, semid_file2, semid_file3,
                  next_cells, dir, move_count, file_lock, toggle, logfile);
    SemSignal(sem_mutex);
    printf("child signalling mutex\n");
    fflush(stdout);
    exit(0);
  } else {
    if (!init) {
      if ((sem_mutex = SemCreate(SEM_MUTEX, 0)) == ERROR) {
        interp->result = "couldn't create mutex semaphore";
        return TCL_ERROR;
      }
      if ((semid_file0 = SemCreate(SEM_FL_KEY0, 0)) == ERROR ||
          (semid_file1 = SemCreate(SEM_FL_KEY1, 0)) == ERROR ||
          (semid_file2 = SemCreate(SEM_FL_KEY2, 0)) == ERROR ||
          (semid_file3 = SemCreate(SEM_FL_KEY3, 0)) == ERROR) {
        interp->result = "couldn't create semaphores for file locks";
        return TCL_ERROR;
      }
    }

    if (!init) init = 1;
  }

  if (!toggle) {  /* write to next set of files on next call */
    Tcl_Eval(interp, cmd0);
    toggle = 1;
  } else if (toggle) {
    Tcl_Eval(interp, cmd1);
    toggle = 0;
  }

  return TCL_OK;
}




int GetFileLocks(ClientData clientData, Tcl_Interp *interp, int argc,
                 char **argv) {

  int num;

  sscanf(argv[1], "%d", &num);

  if (num == 0) {
    SemWait(semid_file0);
  } else if (num == 1) {
    SemWait(semid_file1);
  } else if (num == 2) {
    SemWait(semid_file2);
  } else if (num == 3) {
    SemWait(semid_file3);
  }

  return TCL_OK;
}




int ReleaseFileLocks(ClientData clientData, Tcl_Interp *interp, int argc,
                     char **argv) {

  int num;

  sscanf(argv[1], "%d", &num);

  if (num == 0) {
    SemSignal(semid_file0);
  } else if (num == 1) {
    SemSignal(semid_file1);
  } else if (num == 2) {
    SemSignal(semid_file2);
  } else if (num == 3) {
    SemSignal(semid_file3);
  }

  return TCL_OK;
}





void SetNeighbours(int i, int j) {

  char name[MAX_FILENAMELEN], buf[10];

  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j-1); /* remember Xwin coo. system runs down! */
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i);
  strcat(name, buf);
  strcpy(neighbours.segments[N], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j-1);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i-1);
  strcat(name, buf);
  strcpy(neighbours.segments[NW], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i-1);
  strcat(name, buf);
  strcpy(neighbours.segments[W], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j+1);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i-1);
  strcat(name, buf);
  strcpy(neighbours.segments[SW], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j+1);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i);
  strcat(name, buf);
  strcpy(neighbours.segments[S], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j+1);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i+1);
  strcat(name, buf);
  strcpy(neighbours.segments[SE], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i+1);
  strcat(name, buf);
  strcpy(neighbours.segments[E], name);

  memset(name, '\0', MAX_FILENAMELEN);
  memset(buf, '\0', 10);
  strcpy(name, "seg_0.");
  sprintf(buf, "%d.", j-1);
  strcat(name, buf);
  memset(buf, '\0', 10);
  sprintf(buf, "%d.ppm", i+1);
  strcat(name, buf);
  strcpy(neighbours.segments[NE], name);

}




int SendFileRequest(ClientData clientData, Tcl_Interp *interp, int argc,
                    char **argv) {

  int  dir, getflag;
  char buf[120];
  int  seg0_nw_north, seg0_nw_east, seg0_se_north, seg0_se_east;
  int  seg1_nw_north, seg1_nw_east, seg1_se_north, seg1_se_east;
  int  seg2_nw_north, seg2_nw_east, seg2_se_north, seg2_se_east;
  int  canvas_llx, canvas_lly, canvas_urx, canvas_ury;
  char *string;

  if (argc != 3) {
    interp->result = "SendFileRequest: wrong number of arguments";
    return TCL_ERROR;
  }
  sscanf(argv[1], "%d", &dir);
  sscanf(argv[2], "%d", &getflag);

  if ((string = Tcl_GetVar(interp, "canvas_ury", 0)) == NULL) {
    interp->result = "couldn't get Tcl variable in function:\
                      SendFileRequest";
    return TCL_ERROR;
  }
  sscanf(string, "%d", &canvas_ury);
  if ((string = Tcl_GetVar(interp, "canvas_lly", 0)) == NULL) {
    interp->result = "couldn't get Tcl variable in function:\
                      SendFileRequest";
    return TCL_ERROR;
  }
  sscanf(string, "%d", &canvas_lly);
  if ((string = Tcl_GetVar(interp, "canvas_llx", 0)) == NULL) {
    interp->result = "couldn't get Tcl variable in function:\
                      SendFileRequest";
    return TCL_ERROR;
  }
  sscanf(string, "%d", &canvas_llx);
  if ((string = Tcl_GetVar(interp, "canvas_urx", 0)) == NULL) {
    interp->result = "couldn't get Tcl variable in function:\
                      SendFileRequest";
    return TCL_ERROR;
  }
  sscanf(string, "%d", &canvas_urx);

printf("dir: %d getflag: %d\n", dir, getflag);
  if (dir == 1) {  /* find the new matrix boundary coordinates */
    if (canvas_llx == 0) {
      seg0_se_north = seg1_se_north = mapmat_north;
      seg0_nw_north = seg1_nw_north = seg0_se_north + SEGMENT_HEIGHT*res; 
      seg0_nw_east = seg1_nw_east = mapmat_west;
      seg0_se_east = seg1_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg2_se_north = mapmat_north;
      seg2_nw_north = seg2_se_north + SEGMENT_HEIGHT*res; 
      seg2_nw_east =  seg1_se_east;
      seg2_se_east = seg2_nw_east + SEGMENT_WIDTH*res;
    } else if (canvas_urx == xmax) {
      seg0_se_north = mapmat_north;
      seg0_nw_north = seg0_se_north + SEGMENT_HEIGHT*res; 
      seg0_nw_east =  mapmat_west;
      seg0_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg2_se_north = seg1_se_north = mapmat_north;
      seg2_nw_north = seg1_nw_north = seg1_se_north + SEGMENT_HEIGHT*res; 
      seg2_nw_east =  seg1_nw_east =  seg0_se_east;
      seg2_se_east = seg1_se_east = seg1_nw_east + SEGMENT_WIDTH*res;
    } else {
      seg0_se_north = mapmat_north;
      seg0_nw_north = seg0_se_north + SEGMENT_HEIGHT*res; 
      seg0_nw_east =  mapmat_west;
      seg0_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg1_se_north = mapmat_north;
      seg1_nw_north = seg1_se_north + SEGMENT_HEIGHT*res; 
      seg1_nw_east =  seg0_se_east;
      seg1_se_east = seg1_nw_east + SEGMENT_WIDTH*res;
      seg2_se_north = mapmat_north;
      seg2_nw_north = seg2_se_north + SEGMENT_HEIGHT*res; 
      seg2_nw_east =  seg1_se_east                  ;
      seg2_se_east = seg2_nw_east + SEGMENT_WIDTH*res;
    }
    if (bndry[3]) {
      bndry[3] = 0;
    }
    if (getflag) {
      mapmat_north += SEGMENT_HEIGHT*res;
      mapmat_south += SEGMENT_HEIGHT*res;
    } else {
      mapmat_south += SEGMENT_HEIGHT*res;
      bndry[dir] = 1;
    }
  } else if (dir == 2) {
printf("mapmate: %d mapmatw: %d\n", mapmat_east, mapmat_west);
    if (canvas_lly == ymax) {
      seg0_nw_north = mapmat_north; 
      seg0_se_east = mapmat_west;
      seg0_nw_east =  seg0_se_east - SEGMENT_WIDTH*res;
      seg0_se_north = seg0_nw_north - SEGMENT_HEIGHT*res;
      seg2_nw_north = seg1_nw_north = seg0_se_north;
      seg2_nw_east =  seg1_nw_east =  seg0_nw_east;
      seg2_se_north = seg1_se_north = seg1_nw_north - SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east = seg0_se_east;
    } else if (canvas_ury == 0) {
      seg0_nw_north = seg1_nw_north = seg0_se_north;
      seg0_se_east = seg1_nw_east =  seg0_nw_east;
      seg0_nw_east = seg1_se_north = seg1_nw_north - SEGMENT_HEIGHT*res;
      seg0_se_north = seg1_se_east = seg0_se_east;
      seg2_nw_north = seg1_se_north;
      seg2_nw_east =  seg1_nw_east;
      seg2_se_north = seg2_nw_north - SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east;
    } else {
      seg0_nw_north = mapmat_north; 
      seg0_se_east = mapmat_west;
      seg0_nw_east =  seg0_se_east - SEGMENT_WIDTH*res;
      seg0_se_north = seg0_nw_north - SEGMENT_HEIGHT*res;
      seg1_nw_north = seg0_se_north;
      seg1_nw_east  =  seg0_nw_east;
      seg1_se_north = seg1_nw_north - SEGMENT_HEIGHT*res;
      seg1_se_east = seg0_se_east;
      seg2_nw_north = seg1_se_north;
      seg2_nw_east =  seg1_nw_east;
      seg2_se_north = seg2_nw_north - SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east;
    }
    if (bndry[4]) {
      bndry[4] = 0;
    }
    if (getflag) {
      mapmat_east -= SEGMENT_WIDTH*res;
      mapmat_west -= SEGMENT_WIDTH*res;
    } else {
      mapmat_east -= SEGMENT_WIDTH*res;
      bndry[dir] = 1;
    }
  } else if (dir == 3) {
    if (canvas_llx == 0) {
      seg0_nw_north = seg1_nw_north = mapmat_south;
      seg0_se_north = seg1_se_north = seg0_nw_north + SEGMENT_HEIGHT*res;
      seg0_nw_east =  seg1_nw_east =  mapmat_west;
      seg0_se_east = seg1_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg2_nw_north = seg1_nw_north; 
      seg2_nw_east =  seg1_se_east;
      seg2_se_north = seg2_nw_north + SEGMENT_HEIGHT*res;
      seg2_se_east = seg2_nw_east + SEGMENT_WIDTH*res;
    } else if (canvas_urx == xmax) {
      seg0_nw_north = mapmat_south;
      seg0_nw_east =  mapmat_west;
      seg0_se_north = seg0_nw_north + SEGMENT_HEIGHT*res;
      seg0_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg2_nw_north = seg1_nw_north = seg0_nw_north; 
      seg2_nw_east = seg1_nw_east =  seg0_se_east;
      seg2_se_north = seg1_se_north = seg1_nw_north + SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east = seg1_nw_east + SEGMENT_WIDTH*res;
    } else {
      seg0_nw_north = mapmat_south;
      seg0_nw_east =  mapmat_west;
      seg0_se_north = seg0_nw_north + SEGMENT_HEIGHT*res;
      seg0_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg1_nw_north = seg0_nw_north; 
      seg1_nw_east =  seg0_se_east;
      seg1_se_north = seg1_nw_north + SEGMENT_HEIGHT*res;
      seg1_se_east = seg1_nw_east + SEGMENT_WIDTH*res;
      seg2_nw_north = seg1_nw_north; 
      seg2_nw_east =  seg1_se_east;
      seg2_se_north = seg2_nw_north + SEGMENT_HEIGHT*res;
      seg2_se_east = seg2_nw_east + SEGMENT_WIDTH*res;
    }
    if (bndry[1]) {
      bndry[1] = 0;
    }
    if (getflag) {
      mapmat_north -= SEGMENT_HEIGHT*res;
      mapmat_south -= SEGMENT_HEIGHT*res;
    } else {
      mapmat_north -= SEGMENT_HEIGHT*res;
      bndry[dir] = 1;
    }
  } else  {
printf("mapmate: %d mapmatw: %d\n", mapmat_east, mapmat_west);
    if (canvas_lly == ymax) {
      seg0_nw_north = mapmat_north; 
      seg0_nw_east =  mapmat_east;
      seg0_se_north = seg0_nw_north - SEGMENT_HEIGHT*res;
      seg0_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg2_nw_north = seg1_nw_north = seg0_se_north;
      seg2_nw_east = seg1_nw_east =  seg0_nw_east;
      seg2_se_north = seg1_se_north = seg1_nw_north - SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east = seg0_se_east;
    } else if (canvas_ury == 0) {
      seg0_nw_north = seg1_nw_north = seg0_se_north;
      seg0_nw_east = seg1_nw_east =  seg0_nw_east;
      seg0_se_north = seg1_se_north = seg1_nw_north - SEGMENT_HEIGHT*res;
      seg0_se_east = seg1_se_east = seg0_se_east;
      seg2_nw_north = seg1_se_north;
      seg2_nw_east =  seg1_nw_east;
      seg2_se_north = seg2_nw_north - SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east;
    } else {
      seg0_nw_north = mapmat_north; 
      seg0_nw_east =  mapmat_east;
      seg0_se_north = seg0_nw_north - SEGMENT_HEIGHT*res;
      seg0_se_east = seg0_nw_east + SEGMENT_WIDTH*res;
      seg1_nw_north = seg0_se_north;
      seg1_nw_east =  seg0_nw_east;
      seg1_se_north = seg1_nw_north - SEGMENT_HEIGHT*res;
      seg1_se_east = seg0_se_east;
      seg2_nw_north = seg1_se_north;
      seg2_nw_east =  seg1_nw_east;
      seg2_se_north = seg2_nw_north - SEGMENT_HEIGHT*res;
      seg2_se_east = seg1_se_east;
    }
    if (bndry[2]) {
      bndry[2] = 0;
    }
    if (getflag) {
      mapmat_east += SEGMENT_WIDTH*res;
      mapmat_west += SEGMENT_WIDTH*res;
    } else {
      mapmat_west += SEGMENT_WIDTH*res;
      bndry[dir] = 1;
    }
  }
  if (getflag) {
    sprintf(buf, "%d %d %d %d %d %d %d %d %d %d %d %d",
            seg0_nw_north, seg0_nw_east, seg0_se_north, seg0_se_east,
            seg1_nw_north, seg1_nw_east, seg1_se_north, seg1_se_east,
            seg2_nw_north, seg2_nw_east, seg2_se_north, seg2_se_east);
    printf("sending file request with coords: %s\n", buf);
    if (WriteBytes(datasock, buf, 120) != 120) {
     interp->result = "ERROR: In writing next segment coords to data channel";
     return TCL_ERROR;
    }
  }

  return TCL_OK;
}




int ConfigMapMatrix(ClientData clientData, Tcl_Interp *interp, int argc,
                    char **argv) {

  int  dir, focus_i, focus_j, getflag;
  char buf[20], msgbuf[10];

  if (argc != 5) {
    interp->result = "ConfigMapMatrix: wrong number of arguments";
    return TCL_ERROR;
  }
  sscanf(argv[1], "%d", &dir);
  sscanf(argv[2], "%d", &focus_i);
  sscanf(argv[3], "%d", &focus_j);
  sscanf(argv[4], "%d", &getflag);

  /* wait for signal from child that seg files have been written */
  if (read(pipefd[0], msgbuf, 1) != 1) {
    interp->result = "ERROR: pipe read error";
    return TCL_ERROR;
  }
  if (dir == 1) {  /* rename the files to the new matrix configuration */
   rename ("seg_0.1.0.ppm", "seg_0.2.0.ppm");
   rename ("seg_0.1.1.ppm", "seg_0.2.1.ppm");
   rename ("seg_0.1.2.ppm", "seg_0.2.2.ppm");
   rename ("seg_0.0.0.ppm", "seg_0.1.0.ppm");
   rename ("seg_0.0.1.ppm", "seg_0.1.1.ppm");
   rename ("seg_0.0.2.ppm", "seg_0.1.2.ppm");
   if (getflag) {
     rename ("nseg0.ppm", "seg_0.0.0.ppm");
     rename ("nseg1.ppm", "seg_0.0.1.ppm");
     rename ("nseg2.ppm", "seg_0.0.2.ppm");
   }
   focus_j += 1;
   sprintf(buf, "%d", focus_j);
   Tcl_SetVar(interp, "focus_j", buf, 0);
   SetNeighbours(focus_i, focus_j);
  } else if (dir == 2) {
   rename ("seg_0.0.1.ppm", "seg_0.0.2.ppm");
   rename ("seg_0.0.0.ppm", "seg_0.0.1.ppm");
   rename ("seg_0.1.1.ppm", "seg_0.1.2.ppm");
   rename ("seg_0.1.0.ppm", "seg_0.1.1.ppm");
   rename ("seg_0.2.1.ppm", "seg_0.2.2.ppm");
   rename ("seg_0.2.0.ppm", "seg_0.2.1.ppm");
   if (getflag) {
     rename ("nseg0.ppm", "seg_0.0.0.ppm");
     rename ("nseg1.ppm", "seg_0.1.0.ppm");
     rename ("nseg2.ppm", "seg_0.2.0.ppm");
   }
   focus_i += 1;
   sprintf(buf, "%d", focus_i);
   Tcl_SetVar(interp, "focus_i", buf, 0);
   SetNeighbours(focus_i, focus_j);
  } else if (dir == 3) {
   rename ("seg_0.1.0.ppm", "seg_0.0.0.ppm");
   rename ("seg_0.1.1.ppm", "seg_0.0.1.ppm");
   rename ("seg_0.1.2.ppm", "seg_0.0.2.ppm");
   rename ("seg_0.2.0.ppm", "seg_0.1.0.ppm");
   rename ("seg_0.2.1.ppm", "seg_0.1.1.ppm");
   rename ("seg_0.2.2.ppm", "seg_0.1.2.ppm");
   if (getflag) {
     rename ("nseg0.ppm", "seg_0.2.0.ppm");
     rename ("nseg1.ppm", "seg_0.2.1.ppm");
     rename ("nseg2.ppm", "seg_0.2.2.ppm");
   }
   focus_j -= 1;
   sprintf(buf, "%d", focus_j);
   Tcl_SetVar(interp, "focus_j", buf, 0);
   SetNeighbours(focus_i, focus_j);
  } else {
   rename ("seg_0.0.1.ppm", "seg_0.0.0.ppm");
   rename ("seg_0.0.2.ppm", "seg_0.0.1.ppm");
   rename ("seg_0.1.1.ppm", "seg_0.1.0.ppm");
   rename ("seg_0.1.2.ppm", "seg_0.1.1.ppm");
   rename ("seg_0.2.1.ppm", "seg_0.2.0.ppm");
   rename ("seg_0.2.2.ppm", "seg_0.2.1.ppm");
   if (getflag) {
     rename ("nseg0.ppm", "seg_0.0.2.ppm");
     rename ("nseg1.ppm", "seg_0.1.2.ppm");
     rename ("nseg2.ppm", "seg_0.2.2.ppm");
   }
   focus_i -= 1;
   sprintf(buf, "%d", focus_i);
   Tcl_SetVar(interp, "focus_i", buf, 0);
   SetNeighbours(focus_i, focus_j);
  }
  
  return TCL_OK;
}





int RecvFiles(ClientData clientData, Tcl_Interp *interp, int argc,
              char **argv) {

  int  cell_num, size, pid;
  char *buf, fname[80], tbuf[40];
  FILE *fd;
  static int count, ispipe;

  if (argc != 2) {
    interp->result = "RecvFiles: wrong number of arguments";
    return TCL_ERROR;
  }
  sscanf(argv[1], "%d", &cell_num);
  
  size = SEGMENT_HEIGHT * SEGMENT_WIDTH * 3;
  buf = (char *) malloc(size);
  if (ReadBytes(datasock, buf, size) != size) {
    interp->result = "ERROR: In reading new segment from data channel";
    if (buf) free (buf);
    return TCL_ERROR;
  }
  strcpy(fname, "nseg");
  sprintf(tbuf, "%d.ppm", cell_num-1);
  strcat(fname, tbuf);
  /* fork a child to do parallel I/O */
  if (!ispipe) {   /* create the pipe */
    if (pipe(pipefd) < 0) {
      interp->result = "ERROR: cannot create pipe in funciton: RecvFiles";
      if (buf) free (buf);
      return TCL_ERROR;
    }
    ispipe = 1;   /* flag high */
  }
  if ((pid == fork()) < 0) {
    interp->result = "ERROR: fork error in function: RecvFiles";
    if (buf) free (buf);
    return TCL_ERROR;
  } else if (pid == 0) {  /* child does I/O */
    fd = fopen(fname, "w");
    fprintf(fd, "%s\n", "P6");
    fprintf(fd, "%d\n%d\n%d\n", SEGMENT_HEIGHT, SEGMENT_WIDTH, 255);
    fwrite (buf, size, 1, fd);
    if (count == 2)  {
                           /* signal the parent that files are created */
      if (write(pipefd[1], "1", 1) != 1)
        printf ("ERROR: pipe write error in child \n");
    }
    close(pipefd[0]);
    close(pipefd[1]);  /* close the pipe */
    if (fd) fclose (fd);
    exit(0);
  }
  count++;
  if (count == 3) count = 0;   /* reset the counter */

  if (buf) free (buf);
  return TCL_OK;
}





int SetCellContents(ClientData clientData, Tcl_Interp *interp, int argc,
                    char **argv) {

  int dir;
  int temp1, temp2, temp3, temp4;

  if (argc != 2) {
      interp->result = "wrong # args to function: SetCellContents";
      return TCL_ERROR;
  }

  sscanf(argv[1], "%d", &dir);

  if (dir == 1) {
    temp1 = cell_content[12];
    temp2 = cell_content[13];
    temp3 = cell_content[14];
    temp4 = cell_content[15];
    cell_content[12] = cell_content[8];
    cell_content[13] = cell_content[9];
    cell_content[14] = cell_content[10];
    cell_content[15] = cell_content[11];
    cell_content[8] = cell_content[4];
    cell_content[9] = cell_content[5];
    cell_content[10] = cell_content[6];
    cell_content[11] = cell_content[7];
    cell_content[4] = cell_content[0];
    cell_content[5] = cell_content[1];
    cell_content[6] = cell_content[2];
    cell_content[7] = cell_content[3];
    cell_content[0] = temp1;
    cell_content[1] = temp2;
    cell_content[2] = temp3;
    cell_content[3] = temp4;
  } else if (dir == 2) {
    temp1 = cell_content[3];
    temp2 = cell_content[7];
    temp3 = cell_content[11];
    temp4 = cell_content[15];
    cell_content[3] = cell_content[2];
    cell_content[2] = cell_content[1];
    cell_content[1] = cell_content[0];
    cell_content[0] = temp1;
    cell_content[7] = cell_content[6];
    cell_content[6] = cell_content[5];
    cell_content[5] = cell_content[4];
    cell_content[4] = temp2;
    cell_content[11] = cell_content[10];
    cell_content[10] = cell_content[9];
    cell_content[9] = cell_content[8];
    cell_content[8] = temp3;
    cell_content[15] = cell_content[14];
    cell_content[14] = cell_content[13];
    cell_content[13] = cell_content[12];
    cell_content[12] = temp4;
  } else if (dir == 3) {
    temp1 = cell_content[0];
    temp2 = cell_content[1];
    temp3 = cell_content[2];
    temp4 = cell_content[3];
    cell_content[0] = cell_content[4];
    cell_content[1] = cell_content[5];
    cell_content[2] = cell_content[6];
    cell_content[3] = cell_content[7];
    cell_content[4] = cell_content[8];
    cell_content[5] = cell_content[9];
    cell_content[6] = cell_content[10];
    cell_content[7] = cell_content[11];
    cell_content[8] = cell_content[12];
    cell_content[9] = cell_content[13];
    cell_content[10] = cell_content[14];
    cell_content[11] = cell_content[15];
    cell_content[12] = temp1;
    cell_content[13] = temp2;
    cell_content[14] = temp3;
    cell_content[15] = temp4;
  } else {
    temp1 = cell_content[0];
    temp2 = cell_content[4];
    temp3 = cell_content[8];
    temp4 = cell_content[12];
    cell_content[0] = cell_content[1];
    cell_content[1] = cell_content[2];
    cell_content[2] = cell_content[3];
    cell_content[3] = temp1;
    cell_content[4] = cell_content[5];
    cell_content[5] = cell_content[6];
    cell_content[6] = cell_content[7];
    cell_content[7] = temp2;
    cell_content[8] = cell_content[9];
    cell_content[9] = cell_content[10];
    cell_content[10] = cell_content[11];
    cell_content[11] = temp3;
    cell_content[12] = cell_content[13];
    cell_content[13] = cell_content[14];
    cell_content[14] = cell_content[15];
    cell_content[15] = temp4;
  }

  return TCL_OK;

}





int SaveImage(ClientData clientData, Tcl_Interp *interp, int argc,
              char **argv) {

  int num, dir;
  char buf[10], photoname[80];;

  if (argc != 3) {
      interp->result = "wrong # args to function: SaveImage";
      return TCL_ERROR;
  }

  sscanf(argv[1], "%d", &num);
  sscanf(argv[2], "%d", &dir);

  sprintf(buf, "%d", 1);

  if (dir == 1) {
    if (num == 0) {
      sprintf(photoname, "photo%d.ppm", cell_content[12]);
      rename (photoname, "save0.ppm");
      Tcl_SetVar(interp, "save0_flag", buf, 0);
    } else if (num == 1) {
      sprintf(photoname, "photo%d.ppm", cell_content[13]);
      rename (photoname, "save1.ppm");
      Tcl_SetVar(interp, "save1_flag", buf, 0);
    } else if (num == 2) {
      sprintf(photoname, "photo%d.ppm", cell_content[14]);
      rename (photoname, "save2.ppm");
      Tcl_SetVar(interp, "save2_flag", buf, 0);
    } else if (num == 3) {
      sprintf(photoname, "photo%d.ppm", cell_content[15]);
      rename (photoname, "save3.ppm");
      Tcl_SetVar(interp, "save3_flag", buf, 0);
    }
  } else if (dir == 2) {
    if (num == 0) {
      sprintf(photoname, "photo%d.ppm", cell_content[3]);
      rename (photoname, "save0.ppm");
      Tcl_SetVar(interp, "save0_flag", buf, 0);
    } else if (num == 1) {
      sprintf(photoname, "photo%d.ppm", cell_content[7]);
      rename (photoname, "save1.ppm");
      Tcl_SetVar(interp, "save1_flag", buf, 0);
    } else if (num == 2) {
      sprintf(photoname, "photo%d.ppm", cell_content[11]);
      rename (photoname, "save2.ppm");
      Tcl_SetVar(interp, "save2_flag", buf, 0);
    } else if (num == 3) {
      sprintf(photoname, "photo%d.ppm", cell_content[15]);
      rename (photoname, "save3.ppm");
      Tcl_SetVar(interp, "save3_flag", buf, 0);
    }
  } else if (dir == 3) {
    if (num == 0) {
      sprintf(photoname, "photo%d.ppm", cell_content[0]);
      rename (photoname, "save0.ppm");
      Tcl_SetVar(interp, "save0_flag", buf, 0);
    } else if (num == 1) {
      sprintf(photoname, "photo%d.ppm", cell_content[1]);
      rename (photoname, "save1.ppm");
      Tcl_SetVar(interp, "save1_flag", buf, 0);
    } else if (num == 2) {
      sprintf(photoname, "photo%d.ppm", cell_content[2]);
      rename (photoname, "save2.ppm");
      Tcl_SetVar(interp, "save2_flag", buf, 0);
    } else if (num == 3) {
      sprintf(photoname, "photo%d.ppm", cell_content[3]);
      rename (photoname, "save3.ppm");
      Tcl_SetVar(interp, "save3_flag", buf, 0);
    }
  } else {
    if (num == 0) {
      sprintf(photoname, "photo%d.ppm", cell_content[0]);
      rename (photoname, "save0.ppm");
      Tcl_SetVar(interp, "save0_flag", buf, 0);
    } else if (num == 1) {
      sprintf(photoname, "photo%d.ppm", cell_content[4]);
      rename (photoname, "save1.ppm");
      Tcl_SetVar(interp, "save1_flag", buf, 0);
    } else if (num == 2) {
      sprintf(photoname, "photo%d.ppm", cell_content[8]);
      rename (photoname, "save2.ppm");
      Tcl_SetVar(interp, "save2_flag", buf, 0);
    } else if (num == 3) {
      sprintf(photoname, "photo%d.ppm", cell_content[12]);
      rename (photoname, "save3.ppm");
      Tcl_SetVar(interp, "save3_flag", buf, 0);
    }
  }

  return TCL_OK;
}




int ResetFiles(ClientData clientData, Tcl_Interp *interp, int argc,
               char **argv) {

  int  toggle, indx, num;
  char cellname[80], photoname[80], buf[80];

  if (argc != 4) {
    interp->result = "wrong # args to function: ResetFiles";
    return TCL_ERROR;
  }

  sscanf(argv[1], "%d", &toggle);
  sscanf(argv[2], "%d", &num);
  sscanf(argv[3], "%d", &indx);

  strcpy(cellname, "cell");
  sprintf(buf, "%d", toggle);
  strcat(cellname, buf);
  memset(buf, '\0', 80);
  sprintf(buf, "_%d.ppm", num);
  strcat(cellname, buf);
  strcpy(photoname, "photo");
  memset(buf, '\0', 80);
  sprintf(buf, "%d.ppm", indx);
  strcat(photoname, buf);

  rename (cellname, photoname);

  return TCL_OK;

}





main(int argc, char **argv) {

  Tcl_Interp *interp;
  Tk_Window tkwin;
  char displayname[MAXHOSTNAMELEN+1];
  char *name = "test";
  int code;
  FILE  *fd;
  int   try_count;
  char  errmsg[180];

  logfile = fopen("ui_log", "w");

  /* get the process id */
  fd = fopen("ui_pid", "w");
  fprintf(fd, "%d", (int)getpid());
  fclose(fd);

  /* Establish the signal handler */
  signal(SIGUSR1, MyInterr);          /* exit signal from cgi process */

  /* Setup connection with server and download initial map segments */
  if (SetupConn(&datasock, &ctrlsock, &bound_north, &bound_south, 
                &bound_east, &bound_west, &res, &row, &col) == ERROR) {
    fprintf(logfile, "client exiting!\n");
    exit(1);
  }

  interp = Tcl_CreateInterp();
  FingerHost(displayname, MAXHOSTNAMELEN+1);
  strcat(displayname, ":0");
/*  strcpy(displayname, "sandman.npac.syr.edu:0"); */
  if ((tkwin = Tk_CreateMainWindow(interp, displayname, name, "Tk")) == NULL)
    {
      fprintf(logfile, "%s\n", interp->result);
      fflush(logfile);
      exit(1);
    }
  Tcl_SetVar(interp, "tcl_interactive", isatty(0) ? "1" : "0",
	     TCL_GLOBAL_ONLY);
  if (Tcl_Init(interp) == TCL_ERROR)
    {
      fprintf(logfile, "Tcl_Init failed: %s\n", interp->result);
      fflush(logfile);
    }
  if (Tk_Init(interp) == TCL_ERROR)
    {
      fprintf(logfile, "Tk_Init failed: %s\n", interp->result);
      fflush(logfile);
    }
  Tcl_CreateCommand(interp, "CSetMapBounds", SetMapBounds,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CSetupCanvasCoords", SetupCanvasCoords,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "quit", Quit,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "sendurl", OpenUrl,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CInitDisplay", InitDisplay,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CUpdateLinks", UpdateLinks,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CLookAhead", LookAhead,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CGetFileLocks", GetFileLocks,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CReleaseFileLocks", ReleaseFileLocks,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CSendFileRequest", SendFileRequest,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CConfigMapMatrix", ConfigMapMatrix,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CRecvFiles", RecvFiles,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CSaveImage", SaveImage,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CResetFiles", ResetFiles,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  Tcl_CreateCommand(interp, "CSetCellContents", SetCellContents,
            (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
  fprintf(logfile, "%s\n", "created all tcl commands");
  fflush(logfile);

  code = Tcl_EvalFile(interp, argv[1]);

  if (*interp->result != 0) {
    fprintf(logfile, "%s\n", interp->result);
    fflush(logfile);
  }
  if (code != TCL_OK)
    exit(1);

  Tk_MainLoop();
  exit(0);
}





/* ----------------------------------------------------------------------
Name: CommQuit(int *datasock, int *ctrlsock)
In: None
Out: sockfd
Comments: This function connects the data and control sockets to the
          server and returns the datasockfd and ctrlsockfd
------------------------------------------------------------------------- */
void MyInterr(int signo) {

  printf("ui exiting\n");
  _exit(0);

}





/* ----------------------------------------------------------------------
Name: CommQuit(int *datasock, int *ctrlsock)
In: None
Out: sockfd
Comments: Using putenv to stick to upcoming POSIX.1 standard
------------------------------------------------------------------------- */
void Environ() {

  char str[80];
  char hostname[MAXHOSTNAMELEN+1];

  FingerHost(hostname, MAXHOSTNAMELEN+1);
  strcpy(str, "DISPLAY=");
  strcat(str, hostname);
  strcat(str, ":0");
  putenv(str);

  return;
}
