#include "defs.h"
#include "shmem.h"
#include "mapdefs.h"

void dump_to_file(int n, unsigned char *RGB, int size, int height, int width,
                  int toggle, FILE *logfile)
{
  int i;
  FILE *fd;
  int nb;
  char buf[20];
  
  sprintf(buf, "cell%d_%d.ppm", toggle, n);
  fd = fopen(buf, "w");
  fprintf(fd, "%s\n", "P6");
  fprintf(fd, "%d %d\n", height, width);
  fprintf(fd, "%d\n", 255);
  nb = fwrite(RGB, 1, size, fd);
/*  fprintf(logfile, "nb = %d\n", nb);
  fflush(logfile); */
  fclose(fd);

  return;
}




/* assumes filenames[1] is top left, filenames[2] is top right, */
/* filenames[3] is bottom left, filenames[4] is bottom right */
/* does nothing if one or more of the files given does not exist */ 
void extract_cells(int semid_file0, int semid_file1, int semid_file2,
                   int semid_file3, Next_Cell next_cells[2], int dir,
                   int *move_count, int *file_lock, int toggle,
                   FILE *logfile)  {

  pixel **tempcolors[4];
  unsigned char *cell;
  int i, j, k, l, ii, m, n;
  int height[4];
  int width[4];
  int maxval;
  int ptr;
  int cell_size;
  int TotalHeight, TotalWidth;
  int count;
  int shmid;

  for (i=0; i<2; i++) {
    if (strlen(next_cells[i].next_file) == 0)
      continue;
    if (fopen(next_cells[i].next_file, "r") == NULL) {
	  printf ("File %s does not exist\n", next_cells[i].next_file);
	  return;
    }
  }

  for (i=0; i<2; i++) {
    if (strlen(next_cells[i].next_file) == 0)
      continue;
    process(next_cells[i].next_file, &(height[i]), &(width[i]), &maxval,
	        &(tempcolors[i]));
  }

  cell_size = MAP_CELL_HEIGHT * MAP_CELL_WIDTH * 3 * sizeof(unsigned char);
  cell = (unsigned char *)malloc(cell_size);

  if (dir == 4 || dir == 2) {
    count = 0;
    for (i = 0; i < 2; i++) {
      ii = i;
      if (move_count[1] > 0) {
        if (i == 0) ii = 1;
        if (i == 1) ii = 0;
      }
      if (strlen(next_cells[ii].next_file) == 0) {
        continue;
      }
      for (j = 0; j < MAX_CELL_ROWS; j++) {
        ptr = 0;
        for (l = next_cells[ii].jstart[j]; l < next_cells[ii].jend[j]; l++) {
            for (m = next_cells[ii].istart[j]; m < next_cells[ii].iend[j]; 
                 m++) {
              cell[ptr] = tempcolors[ii][l][m].red;
              cell[ptr+1] = tempcolors[ii][l][m].green;
              cell[ptr+2] = tempcolors[ii][l][m].blue;
              ptr += 3;
            }
        }
        if (next_cells[ii].jstart[j] != next_cells[ii].jend[j]) {
          dump_to_file(count, cell, cell_size, MAP_CELL_HEIGHT, 
                       MAP_CELL_WIDTH, toggle, logfile);
          if (count == 0)
            SemSignal(semid_file0);
          else if (count == 1)
            SemSignal(semid_file1);
          else if (count == 2)
            SemSignal(semid_file2);
          else if (count == 3)
            SemSignal(semid_file3);
          count++;
/*          file_lock[count] = 1; */
        }
      }
    }
  }

  if (dir == 1 || dir == 3) {
    count = 0;
    for (i = 0; i < 2; i++) {
      ii = i;
      if (move_count[2] > 0) {
        if (i == 0) ii = 1;
        if (i == 1) ii = 0;
      }
      if (strlen(next_cells[ii].next_file) == 0)
        continue;
      for (j = 0; j < MAX_CELL_COLS; j++) {
        ptr = 0;
        for (l = next_cells[ii].jstart[j]; l < next_cells[ii].jend[j]; l++) {
            for (m = next_cells[ii].istart[j]; m < next_cells[ii].iend[j]; 
                 m++) {
              cell[ptr] = tempcolors[ii][l][m].red;
              cell[ptr+1] = tempcolors[ii][l][m].green;
              cell[ptr+2] = tempcolors[ii][l][m].blue;
              ptr += 3;
            }
        }
        if (next_cells[ii].istart[j] != next_cells[ii].iend[j]) {
          dump_to_file(count, cell, cell_size, MAP_CELL_HEIGHT, 
                       MAP_CELL_WIDTH, toggle, logfile);
          if (count == 0)
            SemSignal(semid_file0);
          else if (count == 1)
            SemSignal(semid_file1);
          else if (count == 2)
            SemSignal(semid_file2);
          else if (count == 3)
            SemSignal(semid_file3);
          count++;
          /* file_lock[count] = 1; */
        }
      }
    }
  }


  for (i = 0; i < 2; i++) {
    if (strlen(next_cells[i].next_file) == 0)
      continue;
    cleanup(tempcolors[i], height[i]);
  } 

  free(cell);
}


