#ifndef defs_h
#define defs_h

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

#define MAX_FILENAMELEN 50

struct Pixel
{
  unsigned char red;
  unsigned char green;
  unsigned char blue;
};

typedef struct Pixel pixel;

typedef struct Neighbours {
  char segments[8][MAX_FILENAMELEN];
}Neighbours;

typedef struct Next_Cell {
  char next_file[MAX_FILENAMELEN];
  int  jstart[4];
  int  jend[4];
  int  istart[4];
  int  iend[4];
}Next_Cell;

extern pixel **colors;

/* functions in double.c */
extern void process(char *filename, int *height, int *width, int *maxval,
		    pixel ***colors);
extern void cleanup(pixel **what, int height);
extern void magnify(int height, int width);
extern void dump(char *filename, int height, int width, int maxval,
		 pixel **grid);

/*functions in block.c */
/* extern int roundup(float num); */
extern void dump_block(char *filename, int height, int width, int
		       StartVert, int StartHoriz, int maxval);
extern void dump_into_blocks(char *filebase, int height, int width,
			     int maxval, int start);
extern void process_in_blocks(char *filename, int *height, int *width, 
			      int *maxval, pixel ***grid);

/* functions in concat.c */
extern void dump_to_file(int n, unsigned char *RGB, int size, int height, 
                         int width, int toggle, FILE *logfile);
extern void extract_cells(int semid_file0, int semid_file1, int semid_file2,
                          int semid_file3, Next_Cell next_cells[2], int dir,
                          int *move_count, int *file_lock, int toggle,
                          FILE *logfile);

#endif
