#ifndef INIT_H

#include <math.h>
#include "inet.h"
#include "mapdefs.h"

/* external functions */
extern int      errno;
extern char    *sys_errlist[];
extern int      ReadShort2Float(int, float *, int);
extern int      ReadInt(int, int *, int);
extern int      ReadDouble (int, double *, int);
extern int      ReadBytes(int, char *, int);
extern int      WriteBytes(int, char *, int);
extern int      WriteShort(int, short *, int);
extern int      WriteInt(int, int *, int);
extern int      WriteDouble(int, double *, int);

/* functions defined in this module */
int    CommInit(int *datasock, int *ctrlsock);
void   CommQuit(int datasock, int ctrlsock);
int    RecvMapBounds(int datasock, int ctrlsock, int *bound_north, 
                     int *bound_south, int *bound_east,
                     int *bound_west);
void   FindInitRowCol(int bound_north, int bound_south, int bound_east,
                      int bound_west, int north, int east,
                      int res, int *row, int *col);
int    SendInitCoords(int datasock, int ctrlsock, int north, int east);
int    RecvUrlList(int datasock, int ctrlsock);
int    RecvInitSegments(int datasock, int ctrlsock);

#define INIT_H
#endif /* INIT_H */
