#include "inet.h"

#include <unistd.h>

/* funcitons in this file */
int FingerHost(char *, int);
int readn(int, char *, int);
int writen(int, char *, int);
int freadn(char *, int, int, int);
int fwriten(char *, int, int, int);




/* ------------------------------------------------------------ */
int FingerHost(char *hostname, int namelen) {

  if (gethostname(hostname, namelen) == ERROR) {
    printf("ERROR in gethostname \n");
    return (ERROR); 
  }
  return (OK);

}




/* ------------------------------------------------------------ */
int 
  readn(sockfd, ptr, nbytes)

register int sockfd, nbytes;
char *ptr;
{
  
  int nleft, nread;
  
  nleft=nbytes;
  
  while (nleft > 0) {
    nread = read (sockfd, ptr, nleft);
    if (nread < 0) {
      printf("ERROR server: readn error\n");
      return(ERROR);
    } else if (nread == 0) {
      printf("ERROR: End of file reached\n");
      return(ERROR);
    }
    nleft -= nread;
    ptr += nread;
  }
  return (nbytes-nleft);
}




/* ------------------------------------------------------------ */
int
  writen(sockfd, ptr, nbytes)

register int sockfd, nbytes;
char *ptr;
{

  int nleft, nwritten;

  nleft=nbytes;
  while (nleft > 0) {
    nwritten = write(sockfd, ptr, nleft);
    nleft -= nwritten;
    ptr += nwritten;
  }
  return (nbytes-nleft);

}

/* ------------------------------------------------------------ */
int
  fwriten(ptr, nbytes, number, sockfd)

register int sockfd, nbytes;
char *ptr;
int number;
{

  int nleft, nwritten;

  nleft=nbytes;
  while (nleft > 0) {
    nwritten = fwrite(ptr, nleft, number, (FILE *)sockfd);
    nleft -= nwritten;
    ptr += nwritten;
  }
  return (nbytes-nleft);

}

/* ------------------------------------------------------------ */
int 
  freadn(ptr, nbytes, number, sockfd)

register int sockfd, nbytes;
char *ptr;
int number;
{
  
  int nleft, nread;
  
  nleft=nbytes;
  
  while (nleft > 0) {
  nread = fread (ptr, nleft, number, (FILE *)sockfd);
  nleft -= nread;
  ptr += nread;
}
  return (nbytes-nleft);
}
