#include "inet.h"

#include <netdb.h>

#ifndef INADDR_NONE
#define INADDR_NONE  0xffffffff
#endif

u_short portbase=0;




/*--------------------------------------------------------------------------
Name: int OpenSock(char *host, char *service, char *protocol, 
                   struct sockaddr_in  *inaddr, int port)
Out: sockfd
Comments: This function opens a socket on the specified host at the specified 
          port. Returns -1 in case of failure.
--------------------------------------------------------------------------*/
int OpenSock(char *host, char *service, char *protocol, 
             struct sockaddr_in  *inaddr, int port) {

struct hostent   *hse;      /* pointer to host information entry */
struct servent   *pse;      /* pointer to service information entry */
struct protoent  *ppe;      /* pointer to protocol information entry */
                            /* in /etc/protocols */
unsigned long    ddaddr;    /* dotted-decimal number for host name */
int sockfd, type;

bzero((char *)inaddr, sizeof(*inaddr));
inaddr->sin_family = AF_INET;

inaddr->sin_port=htons(port);

if (host != NULL) {                              /* get host IP address */
  if ( (ddaddr = inet_addr(host)) != INADDR_NONE) {  /* dotted-decimal */
    bcopy((char *) &ddaddr, (char *) &inaddr->sin_addr, sizeof(ddaddr));

  }else{
    if ( (hse=gethostbyname(host)) == NULL) {
      printf("ERROR OpenSock: Unknown host %s \n", host);
      return(ERROR);
    }
    bcopy(hse->h_addr, (char *) &inaddr->sin_addr, hse->h_length);
  }
}else{
  inaddr->sin_addr.s_addr = INADDR_ANY;    /* Receive at well know port */
                                           /* at any IP address on machine */
}

if ( (ppe=getprotobyname(protocol)) == NULL)         /* get protocol number */
  printf("ERROR: Can't get protocol entry %s\n", protocol);

if (strcmp(protocol,"tcp") == 0)                 /* set socket type */
  type=SOCK_STREAM;
else
  type=SOCK_DGRAM;

sockfd=socket(AF_INET, type, ppe->p_proto);      /* allocate socket */
if (sockfd < 0)
printf("ERROR: Can't create socket \n");

return (sockfd);

}
