#ifndef SHMEM_H

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

/* shared memory stuff */
#define SEMKEY1 9000
#define SEMKEY2 9001
#define SEMKEY_CGI 9003
#define SHMKEY 9100

static struct sembuf op_lock[2] = {
  0, 0, 0, 
  0, 1, SEM_UNDO
};

static struct sembuf op_unlock[1] = {
  0, -1, SEM_UNDO
};

/* semaphores for synchronization with client process */
static struct sembuf cgi_lock[2] = {
  0, 0, 0,
  0, 1, SEM_UNDO
};

static struct sembuf cli_lock[2] = {
  1, 0, 0,
  1, 1, SEM_UNDO
};

static struct sembuf disp_lock[2] = {
  0, 0, 0,
  0, 1, SEM_UNDO
};

static struct sembuf cgi_unlock[1] = {
  0, -1, SEM_UNDO
};

static struct sembuf cli_unlock[1] = {
  1, -1, SEM_UNDO
};

static struct sembuf disp_unlock[1] = {
  0, -1, SEM_UNDO
};

typedef union semctl_arg {
  int    val;
  struct semid_ds *buf;
  ushort *array;
} semctl_arg;

/* functions defined in this module */
int ShmAlloc(int , int);
int ShmAtch(int , int);
int ShmDtch(char *);
int ShmRel(int );
int SemCreate(int , int );
int SemCreate2(key_t , int, int );
int SemValCheck2(int, int, int );
int SemRem(int );
int SemWait(int );
int SemSignal(int );
int SemOpen(int );
int SemCliWait(int );
int SemCgiWait(int );
int SemDispWait(int );
int SemCliSignal(int );
int SemCgiSignal(int );
int SemDispWait(int );

#define SHMEM_H
#endif /* SHMEM_H */
